/*                                                                                           
*  Touch Sensing Library System Setup File                                                   
*                                                                                            
*  Auto-generated by System Setup Creator Tool                                               
*                                                                                            
*  This file contains electrode and other Touch Sensing System setup parameters              
*/                                                                                           

#ifndef __TSS_SYSTEM_SETUP_H__
#define __TSS_SYSTEM_SETUP_H__



/* Define CTS/ATL low layer sensing algorithm to be used */

#undef TSS_USE_CTS_LOW_LEVEL

#define TSS_USE_ATL_LOW_LEVEL       1

#define TSS_USE_DELTA_LOG           1

#define TSS_USE_GPIO_STRENGTH       0

#define TSS_USE_GPIO_SLEW_RATE      0

#define TSS_USE_IIR_FILTER          1

#define TSS_USE_NOISE_WINDOWING     0

#define TSS_ONFAULT_CALLBACK       TSS_fOnFault       /* Identifier of the user's OnFault callback */

#define TSS_N_ELECTRODES           6                  /* Number of electrodes present in the system */

/* Electrode's GPIOs configuration */


/* Electrodes defines*/
  #define TSS_E0_P                    H               /* Electrode port H*/
  #define TSS_E0_B                    7               /* Electrode bit  7*/
    
  #define TSS_E1_P                    H               /* Electrode port H*/
  #define TSS_E1_B                    6               /* Electrode bit  6*/   

  #define TSS_E2_P                    H               /* Electrode port H*/
  #define TSS_E2_B                    5               /* Electrode bit  5*/
                                                                           
  #define TSS_E3_P                    H               /* Electrode port H*/     
  #define TSS_E3_B                    4               /* Electrode bit  4*/     
                
  #define TSS_E4_P                    H               /* Electrode port H*/     
  #define TSS_E4_B                    3               /* Electrode bit  3*/     
                                                                              
  #define TSS_E5_P                    H               /* Electrode port H*/
  #define TSS_E5_B                    2               /* Electrode bit  2*/


/* Electrode's measurement type configuration */

/* Electrode's Noise Window Size configuration */

/* Controls configuration */

#define TSS_N_CONTROLS              1

#define TSS_C0_TYPE                 TSS_CT_KEYPAD   /* Control type */
#define TSS_C0_ELECTRODES           6               /* Number of electrodes in the control */
#define TSS_C0_STRUCTURE            cKey0           /* Name of the C&S struct to create */
#define TSS_C0_CALLBACK             fCallBack0      /* Identifier of the user's callback */


/* ATL Specific parameter */

#define ATL_HW_TIMER                TPM1             /* Defines the ATL Timer */
#define ATL_SENSOR_PRESCALER         2               /* Defines the ATL Sensor Prescaler */
#define ATL_SENSOR_TIMEOUT          511              /* Defines the ATL Sensor Timeout */

#endif                                               /*__TSS_SYSTEM_SETUP_H__*/
